package main

import (
	"fmt"
	"log"
	"os"
)

func main() {
	var err error

	var config Config
	config.load()
	fmt.Printf("%+v\n", config)

	//get working directory
	wd, err := os.Getwd()
	if err != nil {
		log.Fatal("couldn't find working directory", err)
	}

	// // apply curr.png if already preloaded
	// err = hyprpaperWallpaper(curr)
	// if err != nil {
	// 	//preload curr.png if not
	// 	err = hyprpaperPreload(curr)
	// 	if err != nil {
	// 		fmt.Println("could not preload (this is fine)", err)
	// 	}
	// }

	dir := config.Root + "/chsck"
	randomImg, filename, _ := getRandomFile(dir)
	img := loadImage(randomImg)
	dst := processImage(img, config)
	curr := wd + "/images/" + filename
	log.Println("curr: ", curr)
	saveImage(curr, dst)

	//BUG: hyprpaper won't preload if it recognises the path. SO we need to use images' original names
	err = hyprpaperPreload(curr)
	if err != nil {
		log.Fatal("preload failed!", err)
	}
	err = hyprpaperWallpaper(curr)
	if err != nil {
		log.Fatal("set wallpaper failed!", err)
	}
	err = hyprpaperUnloadAll()
	if err != nil {
		log.Fatal("unload all failed!", err)
	}
}
